#RS-FF with priority Reset
-R[1,0]
-S_Flanke[1,0]
<
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity |Name| is                     
    Port ( s : in std_logic;
           r : in std_logic;  
           q : out std_logic);       
end |Name|;

architecture behavioral of |Name| is 
signal qi : std_logic;
begin
  p1: process(r,s,qi)  
      begin       
        IF r = '|R|' THEN qi <= '0';
	   ELSIF (s'event and s = '|S_Flanke|') THEN qi <= '1'; 
	   END IF; 
        q <= qi;
	 end process p1;
end behavioral;
>


#D-FF
-Taktflanke[1,0]
<
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity |Name| is                     
    Port ( d,clk : in std_logic;  
           q : out std_logic);       
end |Name|;

architecture behavioral of |Name| is 
signal qi : std_logic;
begin
  p1: process(clk)
      begin             
        if (clk'event and clk='|Taktflanke|') then qi <= d; 
                                   else qi <= qi;
        end if;
      end process p1;
  q <= qi;
end behavioral;
>


#D-FF with reset
-Taktflanke[1,0]
-Reset[1,0]
<
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity |Name| is                     
    Port ( d,clk,rst : in std_logic;  
           q : out std_logic);       
end |Name|;

architecture behavioral of |Name| is 
signal qi : std_logic;
begin
  p1: process(clk,rst)
      begin 
        if rst='|Reset|' then qi <='0'; else     
        if (clk'event and clk='|Taktflanke|') then qi <= d; 
                                   else qi <= qi; end if;
        end if;
      end process p1;
  q <= qi;
end behavioral;
>


#JK-FlipFlop
-Taktflanke[1,0]
-Reset[1,0]
-J[1,0]
-K[1,0]
<
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity |Name| is                     
    Port ( j,k,clk,rst : in std_logic;  
           q : out std_logic);       
end |Name|;

architecture behavioral of |Name| is 
signal qi : std_logic; 
begin
 p1: process(clk,rst)   
     begin              
      if rst='|RESET|' then qi <='0';  else      
      if (clk'event and clk='|Taktflanke|') then 
		if j='|J|' then if k='|K|' then qi <= not qi;
 	                          else qi <= '1';    end if;
		         else if k='1' then qi <= '0';
 	                          else qi <= qi;     end if;
      end if;
		end if;
      end if;
     end process p1;
 q <= qi;
end behavioral;
>


#T-FF
-Taktflanke[1,0]
<
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity |Name| is                     
    Port ( t,clk : in std_logic;  
           q : out std_logic);       
end |Name|;

architecture behavioral of |Name| is 
signal qi : std_logic;
begin
  p1: process(clk)   
      begin              
        if (clk'event and clk='|Taktflanke|') then qi <= t xor qi;  end if;
      end process p1;
  q <= qi;
end behavioral;
>


#T-FF with reset
-Taktflanke[1,0]
-Reset[1,0]
<
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity |Name| is                     
    Port ( t,clk,rst : in std_logic;  
           q : out std_logic);       
end |Name|;

architecture behavioral of |Name| is 
signal qi : std_logic;
begin
  p1: process(clk,rst)   
      begin              
        if rst='|Reset|' then qi <='0'; else      
        if (clk'event and clk='|Taktflanke|') then qi <= t xor qi;  end if;
        end if;
      end process p1;
  q <= qi;
end behavioral;
>
