unit u_fehler;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TErrorForm = class(TForm)
    Panel1: TPanel;
    OKButton: TButton;
    Memo: TMemo;
    procedure FormResize(Sender: TObject);
    procedure OKButtonClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    procedure Init(err : longint);
  end;

var
  ErrorForm: TErrorForm;

implementation

{$R *.DFM}

procedure TErrorForm.FormResize(Sender: TObject);
begin
  if width < 2* OKButton.width then width:= 2* OKButton.width;
  OKButton.left:= width div 2 - OKButton.width div 2;
end;

procedure TErrorForm.Init(err : longint);
begin
  Memo.Lines.Clear;
  Memo.Lines.Add('Es sind Fehler in der Automatenbeschreibung vorhanden!');
  Memo.Lines.Add('Es konnte kein VHDL-Code erzeugt werden.');
  Memo.Lines.Add('');
  if ((err and $0001) <> 0) then Memo.Lines.Add('Es wurden keine Eingnge definiert!');
  if ((err and $0002) <> 0) then Memo.Lines.Add('Es wurden keine Ausgnge definiert!');
  if ((err and $0004) <> 0) then Memo.Lines.Add('Es wurden weniger als 2 Zustnde definiert!');
  if ((err and $0008) <> 0) then Memo.Lines.Add('Die Eingangsmatrix ist ungltig!');
  if ((err and $0010) <> 0) then Memo.Lines.Add('Die Ausgangsmatrix ist ungltig!');
  if ((err and $0020) <> 0) then Memo.Lines.Add('Die Automatenbeschreibung ist unvollstndig!');
  if ((err and $0040) <> 0) then Memo.Lines.Add('Es wurden nicht allen Zustnden eine Ausgangsbelegung zugeordnet!');
end;

procedure TErrorForm.OKButtonClick(Sender: TObject);
begin
  close;
end;

end.
