unit u_signals;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ComCtrls, ExtCtrls;

type
  TSignal = class(TObject)
  Constructor Create(Dateiname : string);
  Destructor Free;
  private
    { Private-Deklarationen }
    F_vhdl : TEXTFILE;
    vin,vout,vio,wstr : TStringList;
    name,clk,rst,behavname   : string;
    procedure ReadVHDL(Datei : string);
    function mlz(cnt : integer) : string;   //make Leerzeichen
    function dellzl(s:string) : string;     //entferne Leerzeichen von links
    function dellzr(s:string) : string;     //entferne Leerzeichen von rechts
    procedure portdef(offset : integer);
    procedure AddSignal(name : string; iotyp : integer);
  public
    { Public-Deklarationen }
    function componentdef(offset : integer) : TStringList;
    function entitydef(offset : integer) : TStringList;
    function getclkrst(offset : integer) : TStringList;
    function signalindef(offset : integer) : TStringList;
    function signaloutdef(offset : integer) : TStringList;
    function MapPort(Offset : integer;Kommentar : boolean) : TStringList;
    function bound(Offset : integer) : string;
    function TBMapPort(Offset : integer) : TStringList;
  end;

implementation

Constructor TSignal.Create(Dateiname : string);
begin
  vin:= TStringList.Create;
  vout:= TStringList.Create;
  vio:= TStringList.Create;
  wstr:= TStringList.Create;
  ReadVHDL(Dateiname);
end;

Destructor TSignal.Free;
begin
  wstr.Free;
  vin.Free;
  vout.Free;
  vio.Free;
end;

function TSignal.mlz(cnt : integer) : string;
var s : string;
    i : integer;
begin
  s:='';
  for i:= 0 to cnt-1 do
    s:= s + ' ';
  result:= s;
end;

function TSignal.dellzl(s:string) : string;     //entferne Leerzeichen von links
var i : integer;
begin
  i:= length(s);
  while i > 0 do
  begin
    if s[1] = ' ' then delete(s,1,1)
                  else i:=1; //Abbruch
    dec(i);
  end;
  result:= s;
end;

function TSignal.dellzr(s:string) : string;     //entferne Leerzeichen von rechts
var i :integer;
begin
  i:= length(s);
  while i > 0 do
  begin
    if s[i] = ' ' then delete(s,i,1)
                  else i:= 1; //Abbruch
    dec(i);
  end;
  result:= s;
end;

procedure TSignal.AddSignal(name : string; iotyp : integer);
var sx : string;
    n  : integer;
begin
  sx:= uppercase(name);
  n:= pos('BUS',sx);
  if n > 0 then
  begin
    sx:= copy(name,1,n-1);
    sx:= dellzr(sx);
    sx:= sx + ';';
    name:= sx;
  end;

  vio.Add(name);
  case iotyp of
    1: vin.Add(name);
    2: vout.Add(name);
    3: begin
         vin.Add(name);
         vout.Add('#'+ name);
       end;
  end;
end;

procedure TSignal.ReadVHDL(Datei : string);
var s,sx,sp,sa,st : string;
    scmp,sbehav   : string;
    sio,sn        : string;
    n,i,x,iotyp   : integer;
    b,b1          : boolean;
    vx            : TStringList;
begin
  vin.Clear;
  vout.Clear;
  wstr.Clear;

  assignfile(F_vhdl,Datei);
  {$I-}
  reset(F_vhdl);
  {$I+}
  if ioresult = 0 then
  begin
    b:= false;
    b1:= false;
    sp:= '';
    sa:= '';
    st:= '';
    scmp:= '';
    sbehav:= '';

    while not eof(F_vhdl) do
    begin
      readln(F_vhdl,s);
      sx:= uppercase(s);
      //suche nach Entity Port
      if pos('ENTITY',sx) > 0 then b:= true;
      if b then sp:= sp + s + '|';
      if pos('END',sx) > 0 then b:= false;
      //suche nach Process
      if pos('PROCESS',sx) > 0 then b1:= true;
      if b1 then sa:= sa + s;
      if pos('END',sx) > 0 then b1:= false;
      if pos('ARCHITECTURE',sx) > 0 then sbehav:= s;
    end; //while

    {$I-}
    closefile(F_vhdl);
    {$I+}

    sx:= uppercase(sbehav);
    n:= pos('ARCHITECTURE',sx);
    if n > 0 then delete(sbehav,1,n +12);
    if sbehav <> '' then
    begin
      sbehav:= dellzl(sbehav);
      sx:= uppercase(sbehav);
      n:= pos(' OF ',sx);
      sbehav:= copy(sbehav,1,n-1);
      sbehav:= dellzr(sbehav);
      if sbehav <> '' then behavname:= sbehav;
    end;

    sx:= uppercase(sp);
    n:= pos('ENTITY',sx);
    delete(sp,1,n+5);
    sx:= uppercase(sp);
    n:= pos('IS',sx);
    //entity name
    name:= copy(sp,1,n-1);
    delete(sp,1,n+1);
    name := dellzl(name);
    name := dellzr(name);

    //Portdefinition innerhalb der Entity suchen
    sx:= uppercase(sp);
    n:= pos('PORT',sx);
    if n > 0 then delete(sp,1,n+4);

    sx:= uppercase(sp);
    n:= pos('END',sx);
    if n > 0 then delete(sp,n,length(sp)-n+1);

    if sp <> '' then
    begin
      while ((sp[1] = ' ') or  (sp[1] = '(')) do
        delete(sp,1,1);

      n:= length(sp);
      while (n > 0) do
      begin
        if sp[n] <> ')' then delete(sp,length(sp),1)
                        else n:= 1; //Abbruch
        dec(n);
      end;

      //Signal innerhalb Entity - Port suchen
      if length(sp) > 1 then
      begin
        delete(sp,length(sp),1);
        sp:= dellzr(sp);
        sp:= sp + ';|';

        //IO-Signale listen
        while length(sp) > 0 do
        begin
          n:= pos('|',sp);
          if n > 0 then
          begin
            s:= copy(sp,1,n-1);
            s:= dellzl(s);
            //Kommentar abschneiden
            x:= pos('--',s);
            if x > 0 then s:= copy(s,1,x-1);

            s:= dellzr(s);

            //Buffer ersetzen mit Out
            x:= pos('BUFFER',uppercase(s));
            if x > 0 then
            begin
              sx:= copy(s,1,x-1);
              sx:= sx + 'out';
              s:= sx + copy(s,x+6,length(s) -x-5);
            end;

            sx:= uppercase(s);

            iotyp:= 0;
            if pos('IN ',sx) > 0 then iotyp:= iotyp or 1;
            if pos('OUT ',sx) > 0 then iotyp:= iotyp or 2;

            i:= pos(',',s);
            if i = 0 then Addsignal(s,iotyp)
             else begin
                    i:= pos(':',s);
                    sio:= copy(s,i,length(s)-i+1);
                    delete(s,i,length(s)-i+1);

                    while s <> '' do
                    begin
                      i:= pos(',',s);
                      if i > 0 then
                      begin
                        sn:= copy(s,1,i-1);
                        delete(s,1,i);
                      end
                      else begin
                             sn:= s;
                             s:='';
                           end;

                      if sn <> '' then
                      begin
                        sn:= dellzr(sn);
                        Addsignal(sn + ' ' + sio,iotyp);
                      end;
                    end;
                  end;

            delete(sp,1,n);
          end
          else sp:=''; //Abbruch
        end; //while
      end;
    end;

    if sa <> '' then
    begin
      clk:='';
      rst:='';
      vx:= TStringList.Create;
      sx:= uppercase(sa);
      n:= pos('PROCESS',sx);
      if n > 0 then
      begin
        s:= copy(sa,n+7,length(sa)-7);
        sx:= copy(s,1,pos(')',s)-1);
        n:= pos('(',sx);
        if n > 0 then sx:= copy(sx,n+1,length(sx)-n);

        while sx <> '' do
        begin
          //Kommasep text
          n:= pos(',',sx);
          if n > 0 then
          begin
            vx.Add(copy(sx,1,n-1));
            delete(sx,1,n);
          end
          else begin
                 vx.Add(sx);
                 sx:='';
               end;
        end; //while

        if vx.Count > 0 then
        begin //es gibt evtl. CLK und RST
          sx:= uppercase(s);
          n:= pos('BEGIN',sx);
          if n > 0 then delete(sx,1,n+ 5);

          while (sx <> '') do
          begin
            n:= pos('IF ',sx);
            if n > 0 then delete(sx,1,n+ 1);
            st:= copy(sx,1,pos('THEN',sx)-1);
            for i:= 0 to vx.count-1 do
            begin
              if pos(uppercase(vx.Strings[i]),st) > 0 then
              begin
                scmp:= uppercase(vx.Strings[i]) + #$27+ 'EVENT';
                if pos(scmp,st) > 0 then
                begin //Takt gefunden
                  if clk = '' then
                    if pos('1',st) > 0 then clk:= '+' + vx.Strings[i]  //H-aktiv
                                       else clk:= '-' + vx.Strings[i]; //L-aktiv
                end
                else begin
                       if rst = '' then
                         if pos('1',st) > 0 then rst:= '+' + vx.Strings[i]  //H-aktiv
                                            else rst:= '-' + vx.Strings[i]; //L-aktiv
                     end;
              end;
            end;
            n:= length(st) + 4;
            sx:= copy(sx,n+1,length(sx)-n);

            n:= pos('ELSIF ',sx);
            if n = 0 then n:= pos('ELSE ',sx);

            if n = 0 then
            begin
              rst:=''; //kein ELSE Zweig, rst kann kein Reset sein
              n:= pos('END ',sx);
              if n = 0 then sx:=''  //es gibt keine weiteren IF-Bedingungen Abbruch
                       else begin
                              delete(sx,1,n);
                              delete(sx,1,pos(';',sx));
                            end;
            end
            else begin  //Elsezweig auswerten
                   if clk = '' then
                   begin
                     delete(sx,1,n);
                     delete(sx,1,pos(' ',sx));

                     st:= copy(sx,1,pos('THEN',sx)-1);
                     for i:= 0 to vx.count-1 do
                     begin
                       if pos(uppercase(vx.Strings[i]),st) > 0 then
                       begin
                         scmp:= uppercase(vx.Strings[i]) + #$27+ 'EVENT';
                         if pos(scmp,st) > 0 then
                         begin //Takt gefunden
                           if clk = '' then
                             if pos('1',st) > 0 then clk:= '+' + vx.Strings[i]  //H-aktiv
                                                else clk:= '-' + vx.Strings[i]; //L-aktiv
                         end
                         else begin
                                if rst = '' then
                                  if pos('1',st) > 0 then rst:= '+' + vx.Strings[i]  //H-aktiv
                                                     else rst:= '-' + vx.Strings[i]; //L-aktiv
                              end;
                         end;
                       end;

                   end;

                   n:= pos('IF ',sx);
                   if n = 0 then n:= pos('END ',sx);
                   if n = 0 then n:= pos('ELSE ',sx);
                   if n = 0 then n:= pos('IF ',sx);
                   if n > 0 then delete(sx,1,n-1);
                 end;

            if (clk <> '') then sx:=''; //Abbruch
          end; //while
        end;

        if clk = '' then rst:='';
      end;
      vx.Free;
    end;

  end;
end;

procedure TSignal.portdef(offset : integer);
var s,sl : string;
    i    : integer;
    tstr : TStringList;
begin
  wstr.Clear;
  sl:= mlz(offset);
  wstr.Add(sl + '   PORT(');
  tstr:= TStringList.Create;

  if vin.Count > 0 then
  begin
    for i:= 0 to vin.Count-1 do
       tstr.Add('         ' + vin.Strings[i]);
  end;
  if vout.Count > 0 then
  begin
    for i:= 0 to vout.Count-1 do
       if vout.Strings[i][1] <> '#' then
          tstr.Add('         ' + vout.Strings[i]);
  end;

  if tstr.Count > 0 then
  begin
    for i:= 0 to tstr.Count-1 do
    begin
      s:= tstr.Strings[i];
      if (i = (tstr.count -1)) then s:= copy(s,1,pos(';',s)-1); 
      wstr.Add(sl + s);
    end;
    wstr.Add(sl + '        );');
  end;
  tstr.Free;
end;

function TSignal.signalindef(offset : integer) : TStringList;
var sl : string;
    i  : integer;
begin
  wstr.Clear;
  sl:= mlz(offset);
  if vin.Count > 0 then
  begin
    for i:= 0 to vin.Count-1 do
       wstr.Add(sl + 'Signal ' + vin.Strings[i]);
  end;
  result:= wstr;
end;

function TSignal.signaloutdef(offset : integer) : TStringList;
var sl : string;
    i  : integer;
begin
  wstr.Clear;
  sl:= mlz(offset);
  if vout.Count > 0 then
  begin
    for i:= 0 to vout.Count-1 do
       if vout.Strings[i][1] <> '#' then
       wstr.Add(sl + 'Signal ' + vout.Strings[i]);
  end;
  result:= wstr;
end;

function TSignal.componentdef(offset : integer) : TStringList;
var sl : string;
begin
  sl:= mlz(offset);
  portdef(offset);
  wstr.Insert(0,sl + 'component '+ name);
  wstr.Add(sl + 'end component;');
  result:= wstr;
end;

function TSignal.entitydef(offset : integer) : TStringList;
var sl : string;
begin
  sl:= mlz(offset);
  portdef(offset);
  wstr.Insert(0,sl + 'entity '+ name + ' is');
  wstr.Add(sl + 'end ' + name+ ';');
  result:= wstr;
end;

function TSignal.getclkrst(offset : integer) : TStringList;
var sl,sx : string;
    flanke : boolean;
begin
  wstr.Clear;
  sl:= mlz(offset);
  sx:= mlz(offset+ 8);

  if rst <> '' then
  begin
    if rst[1] = '+' then flanke:= true
                    else flanke:= false;
    wstr.Add(sl + 'prst: PROCESS');
    wstr.Add(sl + '      BEGIN');

    if flanke then
    begin  //+
      wstr.Add(sx + copy(rst,2,length(rst)-1) +
               ' <= ' + #$27+ '0' + #$27 + '; wait for 50 ns;');
      wstr.Add(sx + copy(rst,2,length(rst)-1) +
               ' <= ' + #$27+ '1' + #$27 + '; wait;');
    end
    else begin //-
           wstr.Add(sx + copy(rst,2,length(rst)-1) +
                    ' <= ' + #$27+ '1' + #$27 + '; wait for 50 ns;');
           wstr.Add(sx + copy(rst,2,length(rst)-1) +
                    ' <= ' + #$27+ '0' + #$27 + '; wait;');
         end;

    wstr.Add(sl + '      END PROCESS trst;');
    wstr.Add('');
  end;

  if clk <> '' then
  begin
    if clk[1] = '+' then flanke:= true
                    else flanke:= false;
    wstr.Add(sl + 'pclk: PROCESS');
    wstr.Add(sl + '      BEGIN');
    if flanke then
    begin  //+
      wstr.Add(sx + copy(clk,2,length(clk)-1) +
               ' <= ' + #$27+ '0' + #$27 + '; wait for tb_time;');
      wstr.Add(sx + copy(clk,2,length(clk)-1) +
               ' <= ' + #$27+ '1' + #$27 + '; wait for tb_time;');
    end
    else begin //-
           wstr.Add(sx + copy(clk,2,length(clk)-1) +
                    ' <= ' + #$27+ '1' + #$27 + '; wait for tb_time;');
           wstr.Add(sx + copy(clk,2,length(clk)-1) +
                    ' <= ' + #$27+ '0' + #$27 + '; wait for tb_time;');
         end;

    wstr.Add(sl + '      END PROCESS pclk;');
  end;

  result:= wstr;
end;

function TSignal.MapPort(Offset : integer;Kommentar : boolean) : TStringList;
var i,n          : integer;
    s,sx,sl,lstr : string;
begin
  wstr.clear;

  if vio.Count > 0 then
  begin
    s:= mlz(offset) + 'map_XXX : ' + name + ' port map(';
    lstr:= s;
    wstr.Add(s);

    sl:= mlz(length(s));

    for i:= 0 to vio.Count-1 do
    begin
      s:= vio.Strings[i];
      n:= pos(':',s);
      sx:= copy(s,1,n-1);
      sx:= dellzr(sx);
      if i < vio.Count-1 then sx:= sx + ',';

      if Kommentar = true then
      begin
        s:= copy(s,n+1,length(s)-n-1);
        sx:= sx + ' -- ' + s;
      end;
      wstr.Add(sl + sx);
      lstr:= lstr + sx;
    end;
    wstr.Add(sl + ');');

    if Kommentar = false then
    begin
      lstr:= lstr + ');';
      wstr.Clear;
      wstr.Add(lstr);
    end;
  end;
  result:= wstr;
end;

function TSignal.bound(Offset : integer) : string;
var s : string;
begin
  s:= '';
  if name <> '' then
  begin
    s:= mlz(offset);
    s:= s + 'for all : ' + name + ' use entity work.' + name + '(' + behavname + ');';
  end;
  result:= s;
end;

function TSignal.TBMapPort(Offset : integer) : TStringList;
var i,n          : integer;
    s,sx,sl,lstr : string;
begin
  wstr.clear;

  if vio.Count > 0 then
  begin
    s:= mlz(offset) + 'map_tb' + ' : ' + name + ' port map(';
    lstr:= s;
    sl:= mlz(length(s));

    for i:= 0 to vio.Count-1 do
    begin
      if length(lstr) > 50 then
      begin
        //Zeilenumbruch
        wstr.Add(lstr);
        lstr:= sl;
      end;

      s:= vio.Strings[i];
      n:= pos(':',s);
      sx:= copy(s,1,n-1);
      if sx <> '' then
      begin
        while sx[length(sx)] = ' ' do
          delete(sx,length(sx),1);
      end;
      sx:= sx + '=>' +  sx;
      if i < vio.Count-1 then sx:= sx + ',';
      lstr:= lstr + sx;
    end; //for

    lstr:= lstr + ');';
    wstr.Add(lstr);
  end;
  result:= wstr;
end;

end.
